minix/minix/tests/run

182 lines
4.2 KiB
Plaintext
Raw Normal View History

2005-04-21 16:53:53 +02:00
#!/bin/sh
# Are we running as root?
unset ROOT
if [ "`id -u`" = 0 ]
then ROOT=yes
fi
2005-04-21 16:53:53 +02:00
# Initialization
PATH=:/bin:/usr/bin:/sbin
2005-04-21 16:53:53 +02:00
export PATH
rm -rf DIR* # remove any old junk lying around
passed=`expr 0` # count number of tests run correctly
failed=`expr 0` # count number of tests that failed
skipped=`expr 0` # count number of tests that were skipped
2005-04-21 16:53:53 +02:00
total=`expr 0` # total number of tests tried
badones= # list of tests that failed
# In the lists below, shell scripts should be listed without ".sh" suffix
# Programs that require setuid
setuids="test11 test33 test43 test44 test46 test56 test60 test61 test65 \
Add PTYFS, Unix98 pseudo terminal support This patch adds support for Unix98 pseudo terminals, that is, posix_openpt(3), grantpt(3), unlockpt(3), /dev/ptmx, and /dev/pts/. The latter is implemented with a new pseudo file system, PTYFS. In effect, this patch adds secure support for unprivileged pseudo terminal allocation, allowing programs such as tmux(1) to be used by non-root users as well. Test77 has been extended with new tests, and no longer needs to run as root. The new functionality is optional. To revert to the old behavior, remove the "ptyfs" entry from /etc/fstab. Technical nodes: o The reason for not implementing the NetBSD /dev/ptm approach is that implementing the corresponding ioctl (TIOCPTMGET) would require adding a number of extremely hairy exceptions to VFS, including the PTY driver having to create new file descriptors for its own device nodes. o PTYFS is required for Unix98 PTYs in order to avoid that the PTY driver has to be aware of old-style PTY naming schemes and even has to call chmod(2) on a disk-backed file system. PTY cannot be its own PTYFS since a character driver may currently not also be a file system. However, PTYFS may be subsumed into a DEVFS in the future. o The Unix98 PTY behavior differs somewhat from NetBSD's, in that slave nodes are created on ptyfs only upon the first call to grantpt(3). This approach obviates the need to revoke access as part of the grantpt(3) call. o Shutting down PTY may leave slave nodes on PTYFS, but once PTY is restarted, these leftover slave nodes will be removed before they create a security risk. Unmounting PTYFS will make existing PTY slaves permanently unavailable, and absence of PTYFS will block allocation of new Unix98 PTYs until PTYFS is (re)mounted. Change-Id: I822b43ba32707c8815fd0f7d5bb7a438f51421c1
2015-06-22 19:14:34 +02:00
test69 test73 test74 test78"
# Scripts that require to be run as root
rootscripts="testisofs testvnd testrelpol"
alltests="1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 \
21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 \
2012-02-17 17:12:44 +01:00
41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 \
61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 \
sh1 sh2 interp mfs isofs vnd"
tests_no=`expr 0`
# If root, make sure the setuid tests have the correct permissions
# and make the dir bin-owned.
if [ "$ROOT" ]
then /usr/sbin/chown bin .
/usr/sbin/chown root ${setuids}
chmod 4755 ${setuids}
fi
tests=$alltests
# Are we given any args? If so, we might have to give
# or change our testlist
while getopts 'lt:T' opt
do
case $opt in
l) echo "$alltests"
exit 0
;;
t) tests="$OPTARG"
;;
T) tapmode=yes
diagprefix="# "
;;
?) echo "Usage: run [-l] [-t testlist] [-T]" >&2
echo " -l: list tests, exit" >&2
echo " -t: execute given set of tests, default: all" >&2
echo " -T: produce TAP-format output" >&2
exit 1
esac
done
# Count tests
for i in `echo $tests`; do
if [ -x ./test$i -o -x ./test${i}.sh ]; then
tests_no=`expr $tests_no + 1`
fi
done
if [ $tests_no -eq 0 ]
then
echo "No test binaries found. did you compile?"
exit 1
fi
# Print tests list whenever user asks for TAP mode. It is up
# to the caller to make sure it makes sense, i.e. he knows what it
# represents.
if [ "$tapmode" ]
then echo "1..$tests_no"
fi
if [ "$tests" = "$alltests" ]
then # Print test welcome message
if [ ! "$tapmode" ]; then clear; fi
echo -n "${diagprefix}Running POSIX compliance test suite. "
echo "There are $tests_no tests in total."
echo "${diagprefix}"
fi
# Provide an argument for test63
ARGS_63=`pwd`/mod
runtest() {
i=$1
ARG=$2
# setuid doesn't work with scripts, so we can only run those as root
if echo "$rootscripts" | tr ' ' '\n' | grep "^test${i}\$" >/dev/null
then needroot=1
else needroot=0
fi
# depending on where we are, scripts might have a .sh suffix or not
if [ -x test${i}.sh ]
then NAME=./test${i}.sh
else NAME=./test$i
fi
if [ "$ROOT" ]
then
if [ $needroot -eq 1 ]
then $NAME $ARG || return 1
else su bin -c "$NAME $ARG" || return 1
fi
else
if [ $needroot -eq 1 ]
then echo "skipping test$i, not root." >&2 && return 0
else $NAME $ARG || return 1
fi
fi
return 0
}
# Run all the tests, keeping track of who failed.
for i in `echo $tests`
do
if [ -x ./test$i -o -x ./test${i}.sh ]
then
total=`expr $total + 1`
FAIL=0
ARG=`eval echo "\\${ARGS_$i}"`
if [ "$tapmode" ]
then out=out.$$
rm -f $out
runtest $i $ARG >$out 2>&1
else runtest $i $ARG
fi
FAIL=$?
if [ $FAIL -eq 0 ]
then if [ "$tapmode" ]
then echo "ok test $i"
fi
passed=`expr $passed + 1`
else if [ "$tapmode" ]
then echo "not ok test $i"
fi
failed=`expr $failed + 1`
badones=`echo $badones " " $i`
fi
if [ "$tapmode" ]
then cat $out | sed "s/^/$diagprefix/"
rm -f $out
fi
else
echo "${diagprefix}warning: skipping test$i"
skipped=`expr $skipped + 1`
2005-04-21 16:53:53 +02:00
fi
done
# Print results of the tests.
if [ "$tests" = "$alltests" ]
then echo "${diagprefix}"
if test $total = $passed
then echo "${diagprefix}All $passed tests completed without error ($skipped skipped)."
else echo "${diagprefix}Testing completed. Score: $passed passed, $failed failed, skipped $skipped"
echo "${diagprefix}The following tests failed: $badones"
fi
2005-04-21 16:53:53 +02:00
fi
# if any test failed return an error
if [ $failed -gt 0 ]
then
exit 1
fi
2005-04-21 16:53:53 +02:00
# echo " "